/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#include "animation.h"
#include "application.h"
Animation::~Animation () {}

void Animation::Animate (int startFrame, int endFrame) {
  Init ();
  for (int frame = startFrame; frame <= endFrame; frame++) {
    source->Render (frame, app->GetProject()->GetFPS(), frameBuffer);
    NextFrame ();
    while (gtk_events_pending())
      gtk_main_iteration();
    gdk_flush();
  }
}

void Animation::SetSource (MediaClip *newSrc) {
  source = newSrc;
}

void Animation::ShowFrame (int frame) {
  source->Render (frame, app->GetProject()->GetFPS(), frameBuffer);
  NextFrame ();
};
