/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#include "clip.h"
#include <glib.h>

void Clip::SetName (char *newName) {
  if (name)
    delete name;

  name = g_strdup (newName);
}

Clip::~Clip () {
  if (name)
    delete name;
}

void Clip::Load (XmlToken *src) {
  char *temp = src->GetString ("Name");
  

  if (temp)
    SetName (temp);


  refCount = src->GetInt ("RefCount");
}

void Clip::Save (XmlToken *dest) {
  dest->Clear ();

  if (name)
    dest->AppendString ("Name", name);
  
  dest->AppendInt ("RefCount", refCount);
}
