/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */


#ifndef __CLIPPANEL_H__
#define __CLIPPANEL_H__

#include "clipview.h"
#include "clipinfo.h"
#include "mclip.h"

/** The clip viewer panel.
 *  This class encapsulates the small preview window in the project window. */
class ClipPanel {
  /// Pointer to the main widget
  GtkWidget *widget;
  /// Pointer to the source clip.
  MediaClip *src;
  /// The clip viewer
  ClipViewer *viewer;
  /// The info panel
  ClipInfo   *info;
  /// Builid the basic widget
  void BuildWidget (GtkWidget *parent);
 public:
  /// Make a new clip panel
  ClipPanel (MediaClip *srcClip, GtkWidget *parent);
  virtual ~ClipPanel ();

  /// Set a new source clip.
  void SetSource (MediaClip *newSource);
};

#endif
