/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#include "mclip.h"

/// This is a dummy clip used for test purposes only.
class DummyClip : public MediaClip {
 protected:
  /** Build the class-specific bits of the edit box.
   *  The derived classes should implement this function.
   *  They should add their edit widgets to the parent with gtk_box_pack_start ().  */
  virtual void BuildEditWidget (GtkWidget *parent);
 public:
  DummyClip ();

  /** Erase the dummy clip
   *  This function is a stub. It doesn't do anything, and always returns 0 */
  virtual int Erase ();

  /** Get the length of this clip.
   *  This function is a stub. It doesn't do anything, and always returns 0 */
  virtual int GetLength (int fps);

  /** Get the disk size of this clip.
   *  This function is a stub. It doesn't do anything, and always returns 0 */
  virtual int GetSize ();

  /** Get the location of this clips file(s)
   *  This function is a stub. It doesn't do anything, and always returns "" */ 
  virtual char *GetFileLocation ();

  /** Get cache status of this clip
   *  This function is a stub. It doesn't do anything, and always returns 2 (N/A) */
  virtual int GetCacheStatus ();

  /* Render this clip's data into the current stream.
   * This function is a stud. It doesnt do anything. */
  virtual void Render (int frame, int fps, FrameBuffer *dest);
};
