/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#include "gtkanimwindow.h"

GtkAnimationWindow::~GtkAnimationWindow () {
  if (videoPlayback)
    gtk_widget_destroy (videoPlayback);
};

GtkAnimationWindow::GtkAnimationWindow (int w, int h) 
  : GtkAnimation (w,h) {
  
  videoPlayback = NULL;
  width         = w;
  height        = h;
  Init ();
}

void GtkAnimationWindow::Init () {
  if (!videoPlayback)
    BuildWindow ();
  GtkAnimation::Init ();
}


static gboolean on_videoPlayback_delete_event (GtkWidget *w, GdkEvent *e, gpointer user_data) {
  return TRUE;
}


void GtkAnimationWindow::BuildWindow () {
  GtkWidget *table16;
  GtkWidget *hseparator13;

  videoPlayback = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize (videoPlayback, width+8, height+30);
  gtk_container_border_width (GTK_CONTAINER (videoPlayback), 4);
  gtk_window_set_title (GTK_WINDOW (videoPlayback), "Playback");
  gtk_window_set_policy (GTK_WINDOW (videoPlayback), FALSE, FALSE, FALSE);
  gtk_window_set_wmclass (GTK_WINDOW (videoPlayback), "playback", "playback");
  gtk_signal_connect (GTK_OBJECT (videoPlayback), "delete_event",
                      GTK_SIGNAL_FUNC (on_videoPlayback_delete_event),
                      NULL);
  gtk_widget_show (videoPlayback);
  BuildWidget (videoPlayback);


}
