/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#ifndef __GTKANIMWINDOW_H__
#define __GTKANIMWINDOW_H__

#include "gtkanimation.h"

/** Play an animation in a gtk window. */
class GtkAnimationWindow : public GtkAnimation {
  /// The window used for playback.
  GtkWidget *videoPlayback;
  /// The dimensions of the playback window
  int width, height;
  /** Initialize the frame buffer & vars. 
   *  This function allocates the memory needed for back buffer & creates a new window.*/
  virtual void Init ();

  /// Build the widget to play back in
  void BuildWindow ();

 public:
  /// Destroy the playback object.
  ~GtkAnimationWindow ();
  /** Play back an animation.
   *  @param w the width of the playback window.
   *  @param h the height of the playback window. */
  GtkAnimationWindow (int w, int h);
};

#endif  // __GTKANIMWINDOW_H__
