/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#ifndef __PLAYBUTTONS_H__
#define __PLAYBUTTONS_H__

#include <gtk/gtk.h>

#include "clipview.h"

/// class for play buttons callback
struct PlayButtonsCallback {
  GtkSignalFunc GoStart;
  GtkSignalFunc GoEnd;
  GtkSignalFunc Stop;
  GtkSignalFunc Play;
  GtkSignalFunc PlayInOut;
  GtkSignalFunc Pause;
  GtkSignalFunc GoForward;
  GtkSignalFunc GoBack;
  GtkSignalFunc SetIn;
  GtkSignalFunc SetOut;
  GtkSignalFunc ClearInOut;
};

// Wrapper for the buttons
class PlayButtons {
 public:
  /** Build the clip player control toolbar.
   *  @param cb pointer to callback function jump table
   *  @param parent the parent widget (used for creating pixmaps)
   *  @param user_data data to be sent to callbacks
   *  @param buttons how many buttons to show
   *  @param style what to show */
  static GtkWidget *Build (PlayButtonsCallback *cb, GtkWidget *parent, 
			   gpointer user_data = NULL,
			   ClipViewerStyle buttons = FULL, 
			   GtkToolbarStyle style = GTK_TOOLBAR_BOTH);
};


#endif
