/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */
#include "framebuffer.h"

class ProjectSettings {
  /// Resolution setup for editing
  FBResolution edit;
  /// Resolution setup for final output (and so also for input)
  FBResolution master;
 public:
  /// Default Constructor.
  ProjectSettings ();
  /// Deallocate theese project settings (surprise!).
  ~ProjectSettings ();
  /// Save theese project settings into an XML file.
  void Save (XmlToken *dest);
  /// Save theese projects from an XML file.
  void Load (XmlToken *src);
  /// Show an edit window for the project settings
  void Edit ();
  /// Get the resolution setup (used for building frame buffers).
  FBResolution *GetRes ();
};
