/*
 * Trinity.
 * 
 * Copyright (C) 1999 by Nicholas Francis
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#include "timelinewindow.h"
#include "timeline.h"
#include "timelineedit.h"

#include "pixmaps/zoomin.xpm"
#include "pixmaps/zoomout.xpm"

#include "application.h"

#include <stdlib.h>
  
TimelineWindow::TimelineWindow (Timeline *src) {
  zoom = 1;
  source = src;

  BuildWindow ();

};


TimelineWindow::~TimelineWindow () {}

/*GnomeUIInfo TimelineWindow::toolbar[] = {
  { GNOME_APP_UI_ITEM, N_("Zoom in"), N_("Zoom in"), 
    NULL, NULL, NULL, GNOME_APP_PIXMAP_DATA,
    zoomin_xpm, 0,(GdkModifierType)0, NULL},
  { GNOME_APP_UI_ITEM, N_("Zoom out"), N_("Zoom out"), 
    NULL, NULL, NULL, GNOME_APP_PIXMAP_DATA,
    zoomout_xpm, 0,(GdkModifierType)0, NULL},
  { GNOME_APP_UI_ITEM, N_("Add"), N_("Add selected clip in project window"), 
    AddSelected, NULL, NULL, GNOME_APP_PIXMAP_STOCK, 
    GNOME_STOCK_PIXMAP_COPY, 0,(GdkModifierType)0, NULL},
  GNOMEUIINFO_END
};
*/
/*void TimelineWindow::AddSelected (GtkMenuItem *menuitem, gpointer user_data) {
  if (app->GetProjectWindow()->GetCurrentClip()) {
    ((Timeline *)user_data)->AddClip (app->GetProjectWindow()->GetActiveClip());
  } else
    ShowDialog ("Add active clip", "you must select a clip in the project window"
		"before it can be added to the current timeline");
};
*/
gint TimelineWindow::canvas_event (GnomeCanvasItem *item, GdkEvent *event, gpointer data) {
  return ((TimelineWindow *)data)->CanvasEvent (item, event);
}
 
gint TimelineWindow::CanvasEvent (GnomeCanvasItem *item, GdkEvent *event) {
  return 0;
}

void TimelineWindow::SetSize (int newWidth, int newHeight) {
  width = newWidth;
  height = newHeight;

  gnome_canvas_set_scroll_region (GNOME_CANVAS (editCanvas), 0.0, 0.0, width, height);  
  gtk_widget_set_usize (editCanvas, width, height);  
  
  clipTimer->SetSize (width, 16);
}

/// Build the window
void TimelineWindow::BuildWindow () {
  GtkWidget *table6;
  GtkWidget *vScroll;
  GtkWidget *hScroll;
  GtkWidget *headers;
  GtkWidget *viewport1;
  GtkWidget *vbox8;
  GtkWidget *cliptimer;
  GtkWidget *VSpacer;
  GtkWidget *Frameno;

  window = gnome_app_new ("Trinity - Timeline", "YOHA");

  table6 = gtk_table_new (4, 3, FALSE);
  gtk_widget_show (table6);
  //  gtk_container_add (GTK_CONTAINER (window1), table6);
  gnome_app_set_contents (GNOME_APP(window), table6);
  gtk_table_set_row_spacings (GTK_TABLE (table6), 2);
  gtk_table_set_col_spacings (GTK_TABLE (table6), 2);

  vScroll = gtk_vscrollbar_new (GTK_ADJUSTMENT (gtk_adjustment_new (1, 1, 2, 3, 4, 1)));
  gtk_widget_show (vScroll);
  gtk_table_attach (GTK_TABLE (table6), vScroll, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  hScroll = gtk_hscrollbar_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 0, 0, 0, 0)));
  gtk_widget_show (hScroll);
  gtk_table_attach (GTK_TABLE (table6), hScroll, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  headers = gtk_label_new ("headers");
  gtk_widget_show (headers);
  gtk_table_attach (GTK_TABLE (table6), headers, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_widget_set_usize (headers, 45, -2);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_show (viewport1);
  gtk_table_attach (GTK_TABLE (table6), viewport1, 1, 2, 1, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (viewport1), vbox8);

  // Make the timer
  GtkWidget *clipTimerCanvas = gnome_canvas_new_aa ();
  gtk_widget_show (clipTimerCanvas);
  gtk_box_pack_start (GTK_BOX (vbox8), clipTimerCanvas, FALSE, TRUE, 0);
  clipTimer = 
    new ClipTimer (gnome_canvas_root (GNOME_CANVAS(clipTimerCanvas)), source);
  
  editCanvas = gnome_canvas_new_aa ();
  gtk_widget_show (editCanvas);
  gtk_box_pack_start (GTK_BOX (vbox8), editCanvas, TRUE, TRUE, 0);
  
  GnomeCanvasGroup *editGroup = (GnomeCanvasGroup *)
    gnome_canvas_item_new (gnome_canvas_root (GNOME_CANVAS(editCanvas)), 
			   gnome_canvas_group_get_type (),
			   "x", (double) 0.0, 
			   "y", (double) 16.0, 
			   NULL);
  
  ClipTimer *timer = new ClipTimer(gnome_canvas_root (GNOME_CANVAS(editCanvas)), source);

  editor = 
    new TimelineEdit (editGroup, source);

  VSpacer = gtk_label_new ("");
  gtk_widget_show (VSpacer);
  gtk_table_attach (GTK_TABLE (table6), VSpacer, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_set_usize (VSpacer, -2, 16);

  Frameno = gtk_hruler_new ();
  gtk_widget_show (Frameno);
  gtk_table_attach (GTK_TABLE (table6), Frameno, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_ruler_set_range (GTK_RULER (Frameno), 0, 200, 4.73934, 10);


  //  editCanvas = gnome_canvas_new_aa ();
  //  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolled_window), editCanvas);

  // Make background
  GnomeCanvasItem *item;
  /*  item = gnome_canvas_item_new (gnome_canvas_root (GNOME_CANVAS(editCanvas)),
				gnome_canvas_rect_get_type (),
				"x1", (double) 0,
				"y1", (double) 16,
				"x2", (double) 1000,
				"y2", (double) 1000,
				"fill_color_rgba", (guint) app->GetPrefs()->timeLineBG,
				"outline_color", "black",
				"width_units", 1.0,
				NULL);
  */
  gtk_widget_show (editCanvas);
  gtk_signal_connect (GTK_OBJECT (gnome_canvas_root (GNOME_CANVAS(editCanvas))), "event",
		      (GtkSignalFunc) canvas_event,
		      this);
  
  gtk_widget_show (window);
  BuildToolbar ();
  //  gnome_app_create_toolbar (GNOME_APP(window), toolbar);

}

void TimelineWindow::ZoomIn () {
  editor->SetZoom (editor->GetZoom() * 2.0);
}
void TimelineWindow::ZoomOut () {
  editor->SetZoom (editor->GetZoom() / 2.0);
}
void TimelineWindow::Cut () {
  editor->Cut ();
}
void TimelineWindow::Copy () {
  editor->Copy ();
}
void TimelineWindow::Paste () {
  editor->Paste (); 
}

void TimelineWindow::BuildToolbar () {
  GtkWidget *toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, 
					GTK_TOOLBAR_ICONS);

  gnome_app_set_toolbar (GNOME_APP (window), GTK_TOOLBAR(toolbar));

  GtkWidget *tempbox = gtk_hbox_new (FALSE, 0);
  gtk_toolbar_append_widget (GTK_TOOLBAR (toolbar), tempbox,
			     "HMM", "hmm");
  gtk_widget_show (tempbox);
  /* Create main clip viewer (this makes the play controls & connects them
     to the main app Animation object. */
  ClipViewer *temp = new ClipViewer (source, tempbox, app->GetAnimation(),
				     (ClipViewerStyle) (FULL));

  gtk_toolbar_append_space (GTK_TOOLBAR(toolbar));
  gtk_toolbar_append_item (GTK_TOOLBAR(toolbar), "Cut", 
       "Cut the current clip to the clipboard", NULL, 
       gnome_stock_pixmap_widget_new(window, GNOME_STOCK_PIXMAP_CUT),
       GtkSignalFunc(_Cut), this);
  gtk_toolbar_append_item (GTK_TOOLBAR(toolbar), "Copy", 
       "Copy the current clip to the clipboard", NULL, 
       gnome_stock_pixmap_widget_new(window, GNOME_STOCK_PIXMAP_COPY),
       GtkSignalFunc(_Copy), this);
  gtk_toolbar_append_item (GTK_TOOLBAR(toolbar), "Paste", 
       "Insert a clip from the clipboard", NULL, 
       gnome_stock_pixmap_widget_new(window, GNOME_STOCK_PIXMAP_PASTE),
       GtkSignalFunc(_Paste), this);
  gtk_toolbar_append_space (GTK_TOOLBAR(toolbar));
  gtk_toolbar_append_item (GTK_TOOLBAR(toolbar), "Zoom IN", 
			   "Enlarge the view size",
			   NULL, GetPixmap (zoomin_xpm, window), 
			   GtkSignalFunc(_ZoomIn), this);
  gtk_toolbar_append_item (GTK_TOOLBAR(toolbar), "Zoom OUT", 
			   "Shrink the view size",
			   NULL, GetPixmap (zoomout_xpm, window), 
			   GtkSignalFunc(_ZoomOut), this);
};

/// Handle an app signal
void TimelineWindow::Signal (AppSignal *signal) {}

// Callbacks
void TimelineWindow::_ZoomIn  (GtkMenuItem *menuitem, gpointer user_data) {
  ((TimelineWindow *)user_data)->ZoomIn ();
}

void TimelineWindow::_ZoomOut (GtkMenuItem *menuitem, gpointer user_data) {
  ((TimelineWindow *)user_data)->ZoomOut ();
}

void TimelineWindow::_Cut  (GtkMenuItem *menuitem, gpointer user_data) {
  ((TimelineWindow *)user_data)->Cut ();
}

void TimelineWindow::_Copy (GtkMenuItem *menuitem, gpointer user_data) {
  ((TimelineWindow *)user_data)->Copy ();
}

void TimelineWindow::_Paste (GtkMenuItem *menuitem, gpointer user_data) {
  ((TimelineWindow *)user_data)->Paste ();
}
