#ifndef __TOOLBOX_H__
#define __TOOLBOX_H__

#include <gnome.h>

/** The class defining menus & toolbars. 
 *  This class is basically a container for all menu items, toolbar items, and the
 *  callback functions that connect theese items to the internal application objects. */
class Toolbox {
 public:
  /// Create the main menu
  static void CreateMenu(GnomeApp *);
  /// Create the main toolbar
  static void CreateToolbar (GnomeApp *);
 private:
  static GnomeUIInfo toolbar[];
  
  static GnomeUIInfo import_menu[];
  static GnomeUIInfo file_menu[];
  static GnomeUIInfo tools_menu[];
  static GnomeUIInfo project_menu[];
  static GnomeUIInfo help_menu[];
  static GnomeUIInfo main_menu[];
  static GnomeUIInfo edit_menu[];
  
  // static menu callbacks can go in here
  static void New_project (GtkMenuItem *menuitem, gpointer user_data);
  static void Open_project (GtkMenuItem *menuitem, gpointer user_data);
  static void Save_project (GtkMenuItem *menuitem, gpointer user_data);
  static void Save_project_as (GtkMenuItem *menuitem, gpointer user_data);
  static void Close_project (GtkMenuItem *menuitem, gpointer user_data);
  static void New_folder (GtkMenuItem *menuitem, gpointer user_data);
  static void Rename_folder (GtkMenuItem *menuitem, gpointer user_data);
  static void Delete_folder (GtkMenuItem *menuitem, gpointer user_data);
  static void About (GtkMenuItem *menuitem, gpointer user_data);
  static void ShowAppPrefs (GtkMenuItem *menuitem, gpointer user_data);
  static void Cut (GtkMenuItem *menuitem, gpointer user_data);
  static void Copy (GtkMenuItem *menuitem, gpointer user_data);
  static void Paste (GtkMenuItem *menuitem, gpointer user_data);
};

#endif // __TRINITY_MENU_H__
